#ifndef _AUDIO_H_
#define _AUDIO_H_

#include <stdlib.h>

#include "mad.h"

namespace audio
{
	class stream
	{
	private:
		char* Buffer;
		size_t BufferSize, BufferPos;
		struct mad_decoder Decoder;

		friend enum mad_flow input(void* Data, struct mad_stream* MadStream);
		friend enum mad_flow output(void* Data, const struct mad_header* Header,
			struct mad_pcm* PCM);
		friend enum mad_flow error(void* Data, struct mad_stream* MadStream,
			struct mad_frame* Frame);

	public:
		stream(const char* FileName);
		~stream();

		void play();
	};
};

#endif

